package org.dromara.elevator.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.SpringUtils;
import org.dromara.common.core.utils.ValidatorUtils;
import org.dromara.common.excel.core.ExcelListener;
import org.dromara.common.excel.core.ExcelResult;
import org.dromara.elevator.domain.bo.EHouseInfoBo;
import org.dromara.elevator.domain.vo.EHouseInfoImportVo;
import org.dromara.elevator.domain.vo.EHouseInfoVo;
import org.dromara.elevator.service.IEHouseInfoService;

import java.util.List;

/**
 * 导入电梯基础信息
 *
 * @author zy
 */
@Slf4j
public class EHouseInfoImportListener extends AnalysisEventListener<EHouseInfoImportVo> implements ExcelListener<EHouseInfoImportVo> {

    private final IEHouseInfoService houseInfoService;

    private final Boolean isUpdateSupport;

    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public EHouseInfoImportListener(Boolean isUpdateSupport) {
        this.houseInfoService = SpringUtils.getBean(IEHouseInfoService.class);
        this.isUpdateSupport = isUpdateSupport;
    }

    @Override
    public void invoke(EHouseInfoImportVo houseVo, AnalysisContext context) {

        EHouseInfoVo houseInfo = this.houseInfoService.selectByCode(houseVo.getCode());
        try {
            // 验证是否存在这个用户
            if (ObjectUtil.isNull(houseInfo)) {
                EHouseInfoBo house = BeanUtil.toBean(houseVo, EHouseInfoBo.class);
                ValidatorUtils.validate(house);
                houseInfoService.insertByBo(house);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、小区 ").append(house.getName()).append(" 导入成功");
            } else if (isUpdateSupport) {
                Long houseId = houseInfo.getId();
                EHouseInfoBo houseInfoBo = BeanUtil.toBean(houseVo, EHouseInfoBo.class);
                houseInfoBo.setId(houseId);
                ValidatorUtils.validate(houseInfoBo);
                houseInfoService.updateByBo(houseInfoBo);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、小区 ").append(houseVo.getName()).append(" 更新成功");
            } else {
                failureNum++;
                failureMsg.append("<br/>").append(failureNum).append("、小区 ").append(houseVo.getName()).append(" 已存在");
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、小区 " + houseVo.getName() + " 导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<EHouseInfoImportVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<EHouseInfoImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
